#! -*- coding: utf-8 -*-
import sys

# Flags to control the write_out function
SINGLE_ID =1		# provide a single id for the template
ID_TWICE = 2		# provide the id twice for the template
ID_AND_COURSE = 3       # provide the id and a course number

# eccourses
# Dynamically set:
# - id 
# - number
ECCOURSES_COPY = "COPY eccourses (id, number, name, number_optional, size, active, organisation, location, federal_state, plz, region_category, nuts3, start_date, end_date, description, lecturer_firstname, lecturer_lastname, lecturer_email, lecturer_phone) FROM stdin;"

ECCOURSES_LIST = [
"%d	%d	Testkurs (Beginn: 2016-09-18)		\N	1	1	Hier	16	99817	\N		2016-09-18	2017-03-10		Bernadette	Croissant	course-lecturer@example.com	0123/45 66 77 88 99",
]

# participants
# Dynamically set:
# - id
# - personal_id
PARTICIPANTS_COPY = "COPY participants (created, updated, id, forename, surname, email, birthname, phone, address_postalcode, address_city, address_street, notes, birthday, gender, personal_id, uid, gid) FROM stdin;"
PARTICIPANTS_LIST = [
"2017-01-26 10:02:28.88292	2017-01-26 10:02:28.882939	%d	Eins	Eins	foo@ntvtn.de		0131 454545	21345	Musterburg	Beispielgasse 12		1985-02-23	1	EC-%d	6	8",
"2017-01-26 10:10:18.3344	2017-01-26 10:10:18.334417	%d	Zwei	Zwei	foo@ntvtn.de		0909 231423423	45456	Musterburg	Beispielgasse 23		1990-02-24	0	EC-%d	6	8",
"2017-01-26 10:17:20.651825	2017-01-26 10:17:20.651842	%d	Drei	Drei	foo@ntvtn.de		56567	67678	Musterburg	Beispielgasse 45		1988-02-25	0	EC-%d	6	8",
"2017-01-26 10:22:10.671133	2017-01-26 10:22:10.67115	%d	Vier	Vier	foo@ntvtn.de		0444 343434	44444	Vierstadt	Gasse 4		1974-04-04	1	EC-%d	6	8",
"2017-01-26 10:24:26.541841	2017-01-26 10:24:26.541859	%d	Fünf	Fünf	foo@ntvtn.de		05555 34235231	55555	Fünfhausen	Weg 5		1995-05-05	0	EC-%d	6	8"
]


# participations
# Dynamically set:
# - id
# - paricipant_id
PARTICIPATIONS_COPY = "COPY participations (created, updated, id, participant_id, project_id, start_date, end_date, number_of_breaks, internal_id, uid, gid, completeness, valid, planned_end_date, has_errors) FROM stdin;"
PARTICIPATIONS_LIST = [
"2017-01-26 10:02:55.456875	2017-01-26 10:02:55.456895	%d	%d	1	2017-01-04	\N	\N		6	8	26,0	1	2017-12-22	f",
"2017-01-26 10:17:37.507925	2017-01-26 10:18:29.158774	%d	%d	1	2017-01-01	\N	\N		6	8	100,0	1	2018-12-31	f",
"2017-01-26 10:10:37.233146	2017-01-26 10:16:11.46194	%d	%d	1	2016-01-02	\N	\N		6	8	100,0	0	2017-12-31	f",
"2017-01-26 10:22:29.293405	2017-01-26 10:36:28.264424	%d	%d	1	2017-01-04	2017-01-25	\N		6	8	100,50	1	2018-12-31	f",
"2017-01-26 10:24:43.017896	2017-01-26 10:38:07.50734	%d	%d	1	2016-01-05	2017-01-24	\N		6	8	100,100	1	2018-12-05	f"
]


# outputindicators
# Dynamically set:
# - id (Foreign key, referencing participation id)
# - course_id
OUTPUTINDICATORS_COPY = "COPY outputindicators (id, participant_id, edu_attainment, lm_employment_status, lm_education_training, lm_employment_type, lm_longtermunemployed, hh_jobless, hh_dependentchildren, hh_singleparent, da_homeless, da_rural_area, da_disabled, da_other_disadvantage, da_migrant, da_foreign_background, da_minority, uid, gid, lm_employment_category_lookingforwork, lm_employment_category_employed, lm_employment_category_underemployed, lm_employment_category_selfemployed, lm_employment_category_inactive, edu_attainment_school, edu_attainment_vocational, hh_singleparent_depended, hh_employed, born_germany, da_resident, additional_certification1, additional_certification2, additional_certification3, additional_qualification, edu_attainment_vocational_others, edu_attainment_vocational_others2, edu_attainment_vocational_others_jobtitle, edu_familyeducation, edu_familyeducation_duration, edu_familyeducation_others, edu_familyeducation_rank, edu_familyeducation_rank_others, edu_familyeducation_since, information, information_other, languages_native, languages_native_other, languages_secondary, languages_secondary_other, languages_tertiary, languages_tertiary_other, occupation_edu, occupation_edu_other, partner1, partner1_coop, partner1_other, partner2, partner2_coop, partner2_other, partner3, partner3_coop, partner3_other, target_audience, target_audience_children, target_audience_other, works_with_fathers, works_with_lowedufamilies, works_with_migrationfamilies, works_with_poor, works_with_pregnants, works_with_singleparents, course_id, course_number, course_name, additional_certification4, additional_certification5, additional_certification6, course_date, infomail, lm_employment_category_inactive_employed, person_federal_state, service_address_city, service_address_housenr, service_address_street, service_address_zip_code, service_name, service_organisation, service_website) FROM stdin;"
OUTPUTINDICATORS_LIST=[
"%d	\N	\N	\N	\N	\N	\N	\N	\N	\N	\N	\N	\N	\N	\N	\N	\N	6	8	\N	\N	\N	\N	\N	\N	\N	\N	\N	\N	\N					\N	\N			\N		\N		\N			\N		\N		\N				\N	\N		\N	\N		\N	\N		\N	\N		\N	\N	\N	\N	\N	\N	%d						\N	\N	\N	\N							",
"%d	\N	\N	\N	\N	\N	\N	\N	0	\N	\N	\N	\N	\N	\N	\N	\N	6	8	0	0	0	0	0	4	1	0	0	\N	\N					10	11			\N		\N		\N			48		\N		\N				\N	\N		\N	\N		\N	\N		\N	\N		\N	\N	\N	\N	\N	\N	%d						2017-01-24	\N	\N	9							",
"%d	\N	\N	\N	\N	\N	\N	\N	0	\N	\N	\N	\N	\N	\N	\N	\N	6	8	0	1	0	0	0	4	1	0	0	\N	\N					8	11			\N		\N		\N			\N		\N		\N				\N	\N		\N	\N		\N	\N		\N	\N		\N	\N	\N	\N	\N	\N	%d						\N	\N	\N	\N							",
"%d	\N	\N	\N	\N	\N	\N	\N	0	\N	\N	\N	\N	\N	\N	\N	\N	6	8	0	2	0	0	0	7	1	0	0	\N	\N					9	1			\N		\N		\N			\N		\N		\N				\N	\N		\N	\N		\N	\N		\N	\N		\N	\N	\N	\N	\N	\N	%d						\N	\N	\N	\N							",
"%d	\N	\N	\N	\N	\N	\N	\N	0	\N	\N	\N	\N	\N	\N	\N	\N	6	8	0	1	0	0	0	4	1	0	1	\N	\N					\N	\N			\N		\N		\N			\N		\N		\N				\N	\N		\N	\N		\N	\N		\N	\N		\N	\N	\N	\N	\N	\N	%d						\N	\N	\N	\N							"
]

# resultindicators
# Dynamically set:
# - id
RESULTINDICATORS_COPY = "COPY resultindicators (id, participant_id, status_end_measure, new_job_search, school_job_education, new_qualification, new_job_or_self_employed, uid, gid, reason_for_cancel, reason_for_cancel_else_reason, ec_course_change, ec_new_course_number, ec_new_qualification_ec) FROM stdin;"
RESULTINDICATORS_LIST = [
"%d	\N	\N	\N	\N	\N	\N	6	8	\N	\N	\N	\N	\N",
"%d	\N	\N	\N	\N	\N	\N	6	8	\N		\N		\N",
"%d	\N	\N	\N	\N	\N	\N	6	8	\N		\N		\N",
"%d	\N	\N	0	0	1	\N	6	8	\N		\N		\N",
"%d	\N	1	0	0	0	0	6	8	0		0		\N"
]

# def write_out_courses(count, offset, copy_cmd, rows):
# 
#     print copy_cmd
# 
#     for k in range(count):
#         for l in range(len(rows)):
#             id1 = offset + count * k + l
#             if more_ids:
#                 print line_list[l] % (id1, id1)
#             else:
#                 print line_list[l] % id1
#     print "\\."
#     print ""


def write_out(count, offset, courses, copy_cmd, line_list, more_ids):

    cnt_rows = len(line_list)
    print copy_cmd

    for k in range(count):
        for c in range(courses):
           for l in range(cnt_rows):
               id1 = offset + (cnt_rows * courses) * k + cnt_rows * c + l
               if more_ids == ID_AND_COURSE:
                   print line_list[l] % (id1, offset+c)
               elif more_ids == ID_TWICE:
                   print line_list[l] % (id1, id1)
               else:
                   print line_list[l] % id1
    print "\\."
    print ""


def main(count, offset, courses):
    print "BEGIN;"
    write_out(courses, offset, 1, ECCOURSES_COPY, ECCOURSES_LIST, ID_TWICE)
 
    # Cases generated per loop: len(*LIST (must be all equal)) * courses
    # This determines the umber of loops neede to generate required count
    loops = count / (len(PARTICIPANTS_LIST)*courses)
    write_out(loops, offset, courses, PARTICIPANTS_COPY, PARTICIPANTS_LIST, ID_TWICE)
    write_out(loops, offset, courses, PARTICIPATIONS_COPY, PARTICIPATIONS_LIST, ID_TWICE)
    write_out(loops, offset, courses, OUTPUTINDICATORS_COPY, OUTPUTINDICATORS_LIST, ID_AND_COURSE)
    write_out(loops, offset, courses, RESULTINDICATORS_COPY, RESULTINDICATORS_LIST, SINGLE_ID)
    print "COMMIT;"


def usage():
    programm = "EC"
    print """generate_test_data.py [OPTIONS]
Generate test data in 5 categories for %s.

Options:
    -n VALUE    number of test cases to generate (minimum 15)
    -c VALUE    number of courses to generate
    -s VALUE    skip ids 
    -? -h       this message
""" % programm


if __name__ == "__main__":
    import getopt
    import sys
    try:
        opts, args = getopt.getopt(sys.argv[1:], "n:c:s:h?")
    except getopt.GetoptError as err:
        # print help information and exit:
        print(err) # will print something like "option -a not recognized"
        usage()
        sys.exit(2)

    # Default values
    number = 1005
    courses = 3
    offset = 1000000

    for o, a in opts:
        if o in ("-h", "-?"):
            usage()
            sys.exit()
	elif o == "-n":
            number = int(a)
	elif o == "-c":
            courses = int(a)
	elif o == "-s":
            offset = int(a)
        else:
            assert False, "unhandled option"
            usage()
 
    main(number, offset, courses)
