## -*- coding: utf-8 -*-
<%inherit file="/main.mako" />
<%
mapping={'app_title': h.get_app_title()}
%>
<div class="page-header">
  <h1>Dubletten-Klärung</h1>
</div>
% if request.user:
<div class="row">
  <div class="col-md-10">
    <p>Für 
       % if participant.gender == 0:
         die Teilnehmende
       % elif participant.gender == 1:
         den Teilnehmenden
       % else:
         die/den Teilnehmende/n 
       % endif
       <strong>${participant}, ${participant.personal_id}</strong>  (aus BewEC importiert) wurden 
       mögliche bestehende Teilnehmenden-Daten gefunden.</p><p>Bitte prüfen Sie, ob es sich um eine Dublette handelt 
       und wählen Sie eine der Optionen:</p>
  <ul>
   <li>Teilnahme ergänzen (es handelt sich um dieselbe Person)</li>
   <li>Person hinzufügen (es handelt sich um unterschiedliche Personen)</li>
  </ul>
  </div>
</div>
<form id="matching_clear" name="matching_clear" action="${request.route_url('participants-matching', id=participant.id)}" method="POST">
  <div class="row">
    <div class="col-md-12">
    <input type="hidden" name="csrf_token" value="${request.session.get_csrf_token()}"/>
    <table class="table table-striped table-hover table-condensed datatable-blank">
      <thead>
	<tr>
          <th></th>
	  <th>${_('Name')}</th>
          <th>Teilnehmende ID</th>
          <th>Bearbeiter/in</th>
          <th>Kurs</th>
          <th>Aktion</th>
	</tr>
       </thead>
       <tbody>
       <tr onclick="window.open('${participant_url}')">
        <td class="link"><b>Neu: </b>
        <td class="link"><b>${participant}<b></td>
        <td class="link"><b>${participant.personal_id}<b></td>
        <td class="link"><b>${participant.owner.profile[0]}<b></td>
        <td class="link"><b>${participant_course}<b></td>
        <td></td>
       </tr>
       % for pt, course, url in matches:
         % if url is not None:
         <tr>
          <td class="link" onclick="window.open('${url}')"></td>
          <td class="link" onclick="window.open('${url}')">${pt}</td>
          <td class="link" onclick="window.open('${url}')">${pt.personal_id}</td>
          <td class="link" onclick="window.open('${url}')">${pt.owner.profile[0]}</td>
          <td class="link" onclick="window.open('${url}')">${course}</td>
          <td> <button type="submit" class="btn btn-primary" name="transfer" value="${pt.id}" onclick="preventDefault()">Teilnahme ergänzen</button>
         </tr>
         % else:
         <tr>
          <td></td>
          <td>${pt}</td>
          <td>${pt.personal_id}</td>
          <td>${pt.owner.profile[0]}</td>
          <td>${course}</td>  
          <td> <button type="submit" class="btn btn-primary" name="transfer" value="${pt.id}">Teilnahme ergänzen</button>
         </tr>
         % endif
       % endfor
       </tbody>
     </table>
     </div>
  </div>
  <div class="row">
    &nbsp;
  </div>
  <div class="row">
    <div class="col-md-12">
    <p>Es handelt sich um unterschiedliche Personen:</p>
    </div>
  </div>
  <div class="row">
     <div class="col-md-8 span8 button-pane">
       <button type="submit" class="btn btn-primary" name="">Person hinzufügen</button>
     </div>
  </div>
</form>
% endif
